    .globl jmptohandler
jmptohandler:
    // 保存所有寄存器到栈上
    addi sp, sp, -304
    sd ra, 280(sp)
    sd sp, 272(sp)
    sd gp, 264(sp)
    sd tp, 256(sp)
    sd t0, 248(sp)
    sd t1, 240(sp)
    sd t2, 232(sp)
    sd s0, 224(sp)
    sd s1, 216(sp)
    sd a0, 208(sp)
    sd a1, 200(sp)
    sd a2, 192(sp)
    sd a3, 184(sp)
    sd a4, 176(sp)
    sd a5, 168(sp)
    sd a6, 160(sp)
    sd a7, 152(sp)
    sd s2, 144(sp)
    sd s3, 136(sp)
    sd s4, 128(sp)
    sd s5, 120(sp)
    sd s6, 112(sp)
    sd s7, 104(sp)
    sd s8, 96(sp)
    sd s9, 88(sp)
    sd s10, 80(sp)
    sd s11, 72(sp)
    sd t3, 64(sp)
    sd t4, 56(sp)
    sd t5, 48(sp)
    sd t6, 40(sp)
    
    // 保存sstatus和scause到栈上
    csrr a0, sstatus
    csrr a1, scause
    sd a0, 32(sp)
    sd a1, 24(sp)
    
    // 跳转到信号处理程序
    jalr a2

    // 恢复sstatus和scause
    ld a0, 32(sp)
    ld a1, 24(sp)
    csrw sstatus, a0
    csrw scause, a1
    
    // 恢复所有寄存器
    ld ra, 280(sp)
    ld sp, 272(sp)
    ld gp, 264(sp)
    ld tp, 256(sp)
    ld t0, 248(sp)
    ld t1, 240(sp)
    ld t2, 232(sp)
    ld s0, 224(sp)
    ld s1, 216(sp)
    ld a0, 208(sp)
    ld a1, 200(sp)
    ld a2, 192(sp)
    ld a3, 184(sp)
    ld a4, 176(sp)
    ld a5, 168(sp)
    ld a6, 160(sp)
    ld a7, 152(sp)
    ld s2, 144(sp)
    ld s3, 136(sp)
    ld s4, 128(sp)
    ld s5, 120(sp)
    ld s6, 112(sp)
    ld s7, 104(sp)
    ld s8, 96(sp)
    ld s9, 88(sp)
    ld s10, 80(sp)
    ld s11, 72(sp)
    ld t3, 64(sp)
    ld t4, 56(sp)
    ld t5, 48(sp)
    ld t6, 40(sp)
    
    // 恢复栈指针并返回
    addi sp, sp, 304
    ret
